<script setup lang="ts">
import { RouterLink } from 'vue-router'
import type CartProduct from '@/models/CartProduct'
import { computed, ref, watch } from 'vue'
import { useCartStore } from '@/stores/cart'

const props = defineProps<{
  item: CartProduct
}>()

const store = useCartStore()

const { removeFromCart, incrementCount, decrementCount, setCount } = store

const price = computed(() => {
  const price = props.item.selectedSize.price - props.item.selectedSize.price * (props.item.discount / 100)
  return price.toFixed(0)
})

const count = ref(props.item.count)

watch(() => props.item.count, (value: number) => count.value = value)
watch(count, (value) => {

  if(!value) {
    setCount(props.item.selectedSize.id, 1)
    count.value = 1
  } else {
    setCount(props.item.selectedSize.id, value)
  }
})

function onIncrement(): void {
  incrementCount(props.item.selectedSize.id)
}

function onDecrement(): void {
  if (props.item.count > 1) {
    decrementCount(props.item.selectedSize.id)
  } else {
    removeFromCart(props.item.selectedSize.id)
  }
}

</script>
<template>
  <li class="cart-item">
    <div class="item-img">
      <RouterLink :to="{ name: 'single-product', params: { category: item.category.slug, product: item.slug } }">
        <img :src="item.image" :alt="item.title">
      </RouterLink>
      <button class="close-btn" @click.stop.prevent="removeFromCart(item.selectedSize.id)">
        <i class="fas fa-times"></i>
      </button>
    </div>
    <div class="item-content">
      <h3 class="item-title">
        <RouterLink :to="{ name: 'single-product', params: { category: item.category.slug, product: item.slug } }">
          {{ item.title }}
        </RouterLink>
      </h3>
      <div class="item-price"><span class="currency-symbol">$</span>{{ price }}</div>
      <div class="pro-qty item-quantity">
        <span class="dec qtybtn" @click.prevent.stop="onDecrement">-</span>
        <input type="number" class="quantity-input" v-model="count">
        <span class="inc qtybtn" @click.prevent.stop="onIncrement">+</span>
      </div>
    </div>
  </li>
</template>